% this code processes the output of the main code and generates some graphs
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


% output processing
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[junk,position]=sort(fh);
[LOGPOST,loglh,B0,B,Bdist,Bpol,SIGMAK,SS,fixedeffect,timeeffect,D,DK,STDB,CCC,G,P0,PT,ENTROPIA,ENTROPIAcorr]=logpost_multicountry_joint_RESULTS(xh(:,position(1)),growth2,open2,TT,N,ind2,priorvec,distance,k,kpol,sqrt(diag(VCM)),XX,XY,regPOL,FT);



% coefficient estimates
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
display('----------------------------------------------')
display('Coefficient estimates: posterior modes and std')
BdistEstimates=[Bdist Bdist.*sqrt(diag(HessianMAX(4*N+1:4*N+k,4*N+1:4*N+k)))]
BpolEstimates=[Bpol sqrt(diag(HessianMAX(4*N+k+1:4*N+k+kpol,4*N+k+1:4*N+k+kpol)))]
display('----------------------------------------------')

figure(1)
subplot(2,1,2); plot([-10:.001:10],normcdf(-Bpol(1)*[-10:.001:10]./mean(SIGMAK)));
ylabel('pr. of being market oriented')
axis([-10 10 0 1]); grid; xlabel('Polity2 score');
subplot(2,1,1); plot([-2.5:.001:2.5],normcdf(-Bpol(2)*[-2.5:.001:2.5]./mean(SIGMAK)));
axis([-2.5 2.5 0 1]); grid; xlabel('logarithm of GDP relative to US');
ylabel('pr. of being market oriented')


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% estimated correlation
figure(2)
md=5000;
plot([0:md],exp(-Bdist(1)*[0:md]/(1000))); grid
xlabel('Distance in Km between country i and country j')
ylabel('\rho_{ij}')



% fit
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% share or wrongly predicted policies
display('----------------------------------------------')
ShareWrongPredictions=sum(sum(abs(D).*ind2))/sum(sum(ind2))


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% fraction of correctly predicted switches
PREDICTED=open2-D;
SWITCH=(open2(2:end,:)-open2(1:end-1,:)).*ind2(2:end,:).*ind2(1:end-1,:);
SWITCHmodel=(PREDICTED(2:end,:)-PREDICTED(1:end-1,:)).*ind2(2:end,:).*ind2(1:end-1,:);
ABSSWITCH=abs(SWITCH);
TOTSW=sum(sum(ABSSWITCH));
match0=zeros(TT-1,N);
match1=zeros(TT-1,N);
match2=zeros(TT-1,N);
match3=zeros(TT-1,N);

window=0;
for i=1:N
    for tau=1:TT-1
        if ABSSWITCH(tau,i)==1;
            match0(tau,i)=SWITCH(tau,i)-mean(SWITCHmodel(tau-window:tau+window,i))==0;
        end
    end
end
sum(sum(match0))/TOTSW;

window=1;
for i=1:N
    for tau=1:TT-1
        if ABSSWITCH(tau,i)==1;
            if tau==1
                match1(tau,i)=SWITCH(tau,i)-sign(sum(SWITCHmodel(tau:tau+window,i)))==0;
            elseif tau==TT-1
                match1(tau,i)=SWITCH(tau,i)-sign(sum(SWITCHmodel(tau-window:tau,i)))==0;
            else
                match1(tau,i)=SWITCH(tau,i)-sign(sum(SWITCHmodel(tau-window:tau+window,i)))==0;
            end
        end
    end
end
sum(sum(match1))/TOTSW;

window=2;
for i=1:N
    for tau=1:TT-1
        if ABSSWITCH(tau,i)==1;
            if tau==1
                match2(tau,i)=SWITCH(tau,i)-sign(sum(SWITCHmodel(tau:tau+window,i)))==0;
            elseif tau==2
                match2(tau,i)=SWITCH(tau,i)-sign(sum(SWITCHmodel(tau-1:tau+window,i)))==0;
            elseif tau==TT-2
                match2(tau,i)=SWITCH(tau,i)-sign(sum(SWITCHmodel(tau-window:tau+1,i)))==0;
            elseif tau==TT-1
                match2(tau,i)=SWITCH(tau,i)-sign(sum(SWITCHmodel(tau-window:tau,i)))==0;
            else
                match2(tau,i)=SWITCH(tau,i)-sign(sum(SWITCHmodel(tau-window:tau+window,i)))==0;
            end
        end
    end
end


window=3;
for i=1:N
    for tau=1:TT-1
        if ABSSWITCH(tau,i)==1;
            if tau==1
                match3(tau,i)=SWITCH(tau,i)-sign(sum(SWITCHmodel(tau:tau+window,i)))==0;
            elseif tau==2
                match3(tau,i)=SWITCH(tau,i)-sign(sum(SWITCHmodel(tau-1:tau+window,i)))==0;
            elseif tau==3
                match3(tau,i)=SWITCH(tau,i)-sign(sum(SWITCHmodel(tau-2:tau+window,i)))==0;
            elseif tau==TT-3
                match3(tau,i)=SWITCH(tau,i)-sign(sum(SWITCHmodel(tau-window:tau+2,i)))==0;
            elseif tau==TT-2
                match3(tau,i)=SWITCH(tau,i)-sign(sum(SWITCHmodel(tau-window:tau+1,i)))==0;
            elseif tau==TT-1
                match3(tau,i)=SWITCH(tau,i)-sign(sum(SWITCHmodel(tau-window:tau,i)))==0;
            else
                match3(tau,i)=SWITCH(tau,i)-sign(sum(SWITCHmodel(tau-window:tau+window,i)))==0;
            end
        end
    end
end

ShareCorrectPredictionsSwitches=[sum(sum(match0))/TOTSW sum(sum(match1))/TOTSW sum(sum(match2))/TOTSW sum(sum(match3))/TOTSW]


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% figures with fitted values
figure(3)
Mwrong=sum((D.*ind2),2)./sum((ind2),2);  % mean of the wrong prediction
sample = [1951:2001];
Mopen=sum(open2.*ind2,2)./sum(ind2,2);
plot(sample,Mopen,'LineWidth',3); hold on;
plot(sample,Mopen-Mwrong,'r-.','LineWidth',3)
legend('Data','Model')
axis([1950 2002 0 1])

figure(4)
cd data
load regions.txt 
cd ..
regions=logical(regions);
for j=1:8
    subplot(4,2,j); plot(sample,sum(open2(:,regions(:,j)).*ind2(:,regions(:,j)),2)./sum(ind2(:,regions(:,j)),2),...
        'LineWidth',2); hold on
    plot(sample,sum(open2(:,regions(:,j)).*ind2(:,regions(:,j)),2)./sum(ind2(:,regions(:,j)),2)-...
        sum(D(:,regions(:,j)).*ind2(:,regions(:,j)),2)./sum(ind2(:,regions(:,j)),2),'r-.','LineWidth',2);
    axis([1949 2002 -0.1 1.1])
    if j==1
        title('(a) North and Central America and Caribean')
    elseif j==2
        title('(b) South America')
        legend('Data','Model')
    elseif j==3
        title('(c) Western Europe')
    elseif j==4
        title('(d) South, East, South-East Asia and Oceania' )
    elseif j==5
        title('(e) North Africa and Middle East')
    elseif j==6
        title('(f) Sub-Saharan Africa')
    elseif j==7
        title('(g) East and Central Europe')
    elseif j==8
        title('(h) Ex-Soviet block')
    end
end



% evolution of beliefs and precision
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% evolution of beliefs
BB=B(N+1:end,:)-B(1:N,:);

figure(5)
auxgraph=[[1950:2001]' prctile(BB,10)';[2001:-1:1950]' prctile(BB(:,end:-1:1),90)'];
patch(auxgraph(:,1),auxgraph(:,2),[.6 .6 1]); hold on

auxgraph=[[1950:2001]' prctile(BB,20)';[2001:-1:1950]' prctile(BB(:,end:-1:1),80)'];
patch(auxgraph(:,1),auxgraph(:,2),[.4 .4 .75]); hold on

auxgraph=[[1950:2001]' prctile(BB,30)';[2001:-1:1950]' prctile(BB(:,end:-1:1),70)'];
patch(auxgraph(:,1),auxgraph(:,2),[.2 .2 .5]); hold on

auxgraph=[[1950:2001]' prctile(BB,40)';[2001:-1:1950]' prctile(BB(:,end:-1:1),60)'];
patch(auxgraph(:,1),auxgraph(:,2),[0 0 .25]); hold on
grid
axis([1950 2001 -.05 .03])


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% evolution of precisions
STDdiff=sqrt(STDB(N+1:end,:).^2+STDB(1:N,:).^2-2*CCC);

figure(6)
auxgraph=[[1950:2001]' prctile(STDdiff,10)';[2001:-1:1950]' prctile(STDdiff(:,end:-1:1),90)'];
patch(auxgraph(:,1),auxgraph(:,2),[.6 .6 1]); hold on

auxgraph=[[1950:2001]' prctile(STDdiff,20)';[2001:-1:1950]' prctile(STDdiff(:,end:-1:1),80)'];
patch(auxgraph(:,1),auxgraph(:,2),[.4 .4 .75]); hold on

auxgraph=[[1950:2001]' prctile(STDdiff,30)';[2001:-1:1950]' prctile(STDdiff(:,end:-1:1),70)'];
patch(auxgraph(:,1),auxgraph(:,2),[.2 .2 .5]); hold on

auxgraph=[[1950:2001]' prctile(STDdiff,40)';[2001:-1:1950]' prctile(STDdiff(:,end:-1:1),60)'];
patch(auxgraph(:,1),auxgraph(:,2),[0 0 .25]); hold on
grid
axis([1950 2001 0 .03])




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% crossing time: counterfactual with respect to rho
flagSTDdB=1;
dr=3;           % distance for which vary the rho
estpr=xh(:,position(1));
[Bcount,hest,STDdBest]=logpost_multicountry_joint_RESULTS_crossing(estpr,growth2,open2,TT,N,ind2,priorvec,distance,k,kpol,sqrt(diag(VCM)),XX,XY,regPOL,FT,flagSTDdB);
XXX=-log([.01:.01:1])/dr;
CROSS=zeros(length(XXX),1);
CROSStime=zeros(length(XXX),N);
H=zeros(length(XXX),1);
medSTDdB=zeros(length(XXX),TT+1);
count=0;
for xxx=XXX;
    count=count+1;
    estpr(4*N+1)=log(xxx);
    if xxx==0;
        [Bcount]=logpost_multicountry_joint_RESULTS_crossing_new(estpr,growth2,open2,TT,N,ind2,priorvec,distance,k,kpol,sqrt(diag(VCM)),XX,XY,regPOL,FT);
    else
        [Bcount,h,STDdB]=logpost_multicountry_joint_RESULTS_crossing(estpr,growth2,open2,TT,N,ind2,priorvec,distance,k,kpol,sqrt(diag(VCM)),XX,XY,regPOL,FT,flagSTDdB);
        medSTDdB(count,:)=median(STDdB);
    end

    H(count)=h;

    meddB=median(Bcount(N+1:2*N,:)-Bcount(1:N,:));
    dB=Bcount(N+1:2*N,:)-Bcount(1:N,:);

    cross=find(meddB>0);
    if isempty(cross)==1
        CROSS(count)=2001;
    else
        CROSS(count)=cross(1)+1949;
    end

    for i=1:N
        cross=find(dB(i,:)>0);
        if isempty(cross)==1
            CROSStime(count,i)=2001;
        else
            CROSStime(count,i)=cross(1)+1949;
        end
    end
end

figure(8)
plot(exp(-dr*XXX),CROSS)

% counterfactuals (GD)
cd counterfactual
M=2000;
main_diffGD
cd ..