function [Ysim,Xosim]=counterfactual(estpr,Y,X,T,N,ind,priorvec,distance,k,kpol,diagsqrtVCM,XX,XY,regPOL,FT,VCM,invVCM,path,T0,Tnew,bbtrue,GrowthShocks,PolShocks,pcgdp,ind_pcgdp,relGDPbar,OPEN1bar,flagGDP,flagOPEN,aaa,bbb);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%profile on

% parameters bounds and econometrician's priors
b0mean=priorvec(1:2);
b0std=priorvec(3);
scaleS=priorvec(4);
degS=priorvec(5);
minS=priorvec(6);
degk=priorvec(7);
scalek=priorvec(8);
minsigmak=priorvec(9);
maxcorr=priorvec(10);
FEmean=priorvec(11);
FEstd=priorvec(12);


% parameter definitions
b0=estpr(1:2*N);
S=exp(estpr(2*N+1:3*N))+minS;
sigmak=exp(estpr(3*N+1:4*N))+minsigmak;
bdist=exp(estpr(4*N+1:4*N+k));
if kpol>=1
    bpol=estpr(4*N+k+1:4*N+k+kpol);
end
if FT==0;
    fixedeffect=zeros(N,1);
    timeeffect=zeros(T,1);
elseif FT==1
    fixedeffect=estpr(4*N+k+kpol+1:5*N+k+kpol);
    timeeffect=zeros(T,1);
elseif FT==2
    fixedeffect=estpr(4*N+k+kpol+1:5*N+k+kpol);
    timeeffect=estpr(5*N+k+kpol+1:5*N+k+kpol+T);
end


% constructing the prior VCM of the betas
BDIST=repmat(permute(bdist,[3 2 1]),[N,N,1]);
v=maxcorr*exp(-sum(distance(:,:,1:k).*BDIST,3)); v=v-diag(diag(v))+eye(N);
if isinf(bdist)==1;
    v=eye(N);
end
Pold=(kron(eye(2),diag(1./S)*diag(1./diagsqrtVCM)/v*diag(1./diagsqrtVCM)*diag(1./S)));
bold=b0;

for t=1:T0

    Pnew=Pold+XX(:,(t-1)*2*N+1:t*2*N);
    boldG=bold(1:N);
    boldM=bold(N+1:end);
    bnew=Pnew\(Pold*bold+XY(:,t));

    
    bold=bnew;
    Pold=Pnew;
end


bigY=zeros(T0+Tnew,N); bigY(1:T0,:)=Y(1:T0,:);
bigX=zeros(T0+Tnew,N); bigX(1:T0,:)=X(1:T0,:);
GDP=zeros(T0+Tnew,N); GDP(1:T0,:)=pcgdp(1:T0,:);
ind_GDP=zeros(T0+Tnew,N); ind_GDP(1:T0,:)=ind_pcgdp(1:T0,:);

for t=T0+1:T0+Tnew

    if kpol==0
        bpol_regPOLT0=0;
    else
        if flagGDP==0 | t==T0+1
            regPOLT0=regPOL([T0:T:T0+(kpol-1)*T],:);
            bpol_regPOLT0=sum(repmat(bpol,1,N).*regPOLT0)';
        elseif flagGDP==1 & kpol==1
            bpol_regPOLT0=bpol(flagGDP)*relGDP';
        else
            regPOLT0=regPOL([T0:T:T0+(kpol-1)*T],:);
            regPOLT0(flagGDP,:)=[];
            bpol_regPOLT0=sum(repmat(bpol([1:flagGDP-1 flagGDP+1:end]),1,N).*regPOLT0,1)';
            bpol_regPOLT0=bpol_regPOLT0+bpol(flagGDP)*relGDP';
        end
    end

    bigX(t,:)=(bnew(N+1:2*N,:)-bnew(1:N,:)>timeeffect(T0)+fixedeffect+bpol_regPOLT0+PolShocks(t-T0,:)')';
    bigY(t,:)=bbtrue(1:N)'.*(1-bigX(t,:))+bbtrue(N+1:2*N)'.*bigX(t,:)+path(t-T0)*(aaa*bigX(t,:)+bbb*(1-bigX(t,:)))+GrowthShocks(t-T0,:);

    xt=sparse([diag(1-bigX(t,:)) diag(bigX(t,:))]); xt(logical(1-ind(T0,:)),:)=0;
    yt=bigY(t,:)';                                  yt(logical(1-ind(T0,:)),:)=0;
    XXt=xt'*invVCM*xt;
    XYt=xt'*invVCM*yt;

    Pnew=Pold+XXt;
    boldG=bold(1:N);
    boldM=bold(N+1:end);
    bnew=Pnew\(Pold*bold+XYt);

    bold=bnew;
    Pold=Pnew;

    ind_GDP(t,:)=ind(T0,:);
    GDP(t,:)=GDP(t-1,:).*(1+yt');
    meanGDP=sum(GDP(t-4:t,:).*ind_GDP(t-4:t,:))./sum(ind_GDP(t-4:t,:));
    relGDP=log(meanGDP)-log(meanGDP(125)) - (relGDPbar);
    
    if flagOPEN>=1
        regPOL(flagOPEN*T0,:)=bigX(t,:)-OPEN1bar;
    end
end

Ysim=bigY(T0:end,:);
Xosim=bigX(T0:end,:);