function [LOGPOST,loglh,b0,B,bdist,bpol,sigmak,S,fixedeffect,timeeffect,D,DK,STDB,CCC,G,P0,Pnew,ENTROPIA,ENTROPIAcorr]=logpost_multicountry_joint_RESULTS(estpr,Y,X,T,N,ind,priorvec,distance,k,kpol,diagsqrtVCM,XX,XY,regPOL,FT);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% parameters bounds and econometrician's priors
b0mean=priorvec(1:2);
b0std=priorvec(3);
scaleS=priorvec(4);
degS=priorvec(5);
minS=priorvec(6);
degk=priorvec(7);
scalek=priorvec(8);
minsigmak=priorvec(9);
maxcorr=priorvec(10);
FEmean=priorvec(11);
FEstd=priorvec(12);


% parameter definitions
b0=estpr(1:2*N);
S=exp(estpr(2*N+1:3*N))+minS;
sigmak=exp(estpr(3*N+1:4*N))+minsigmak;
bdist=exp(estpr(4*N+1:4*N+k));
if kpol>=1
    bpol=estpr(4*N+k+1:4*N+k+kpol);
end
if FT==0;
    fixedeffect=zeros(N,1);
    timeeffect=zeros(T,1);
elseif FT==1
    fixedeffect=estpr(4*N+k+kpol+1:5*N+k+kpol);
    timeeffect=zeros(T,1);
elseif FT==2
    fixedeffect=estpr(4*N+k+kpol+1:5*N+k+kpol);
    timeeffect=estpr(5*N+k+kpol+1:5*N+k+kpol+T);
end


% constructing the prior VCM of the betas
BDIST=repmat(permute(bdist,[3 2 1]),[N,N,1]);
v=maxcorr*exp(-sum(distance(:,:,1:k).*BDIST,3)); v=v-diag(diag(v))+eye(N);
if isinf(bdist)==1;
    v=eye(N);
end
P0=(kron(eye(2),diag(1./S)*diag(1./diagsqrtVCM)/v*diag(1./diagsqrtVCM)*diag(1./S)));
Pold=P0;
bold=b0;


loglh=0;
D=zeros(T,N);
DK=zeros(T,N);
G=zeros(2*N,N,T);
B(:,1)=bold;
invPold=inv(Pold);
STDB(:,1)=sqrt(diag(invPold));
CCC(:,1)=diag(invPold(1:N,N+1:end));

ENTROPIA=zeros(T+1,1);
invCORR=diag(sqrt(1./diag(Pold)))*Pold*diag(sqrt(1./diag(Pold)));
ENTROPIA(1)=[2*N*log(2*pi*exp(1))-sum(log(diag(Pold)))-log(det(invCORR))]/(2*log(2));

ENTROPIAcorr=zeros(T+1,1);
ENTROPIAcorr=zeros(T+1,1);
ENTROPIAcorr(1)=[2*N*log(2*pi*exp(1))+2*log(det(v))]/(2*log(2));

for t=1:T

    Pnew=Pold+XX(:,(t-1)*2*N+1:t*2*N);
    
    xt=sparse([diag(1-X(t,:)) diag(X(t,:))]); xt(logical(1-ind(t,:)),:)=0;
    gt=Pnew\xt';
    G(:,:,t)=gt;
    
    boldG=bold(1:N);
    boldM=bold(N+1:end);
    bnew=Pnew\(Pold*bold+XY(:,t));

    if kpol>=1
        regPOLt=regPOL([t:T:t+(kpol-1)*T],ind(t,:));
        PSI=normcdf(boldM(ind(t,:))-boldG(ind(t,:))-timeeffect(t)-fixedeffect(ind(t,:))-sum(repmat(bpol,1,sum(ind(t,:))).*regPOLt,1)',0,sigmak(ind(t,:)));
    else
        PSI=normcdf(boldM(ind(t,:))-boldG(ind(t,:))-timeeffect(t)-fixedeffect(ind(t,:)),0,sigmak(ind(t,:)));
    end

    x=X(t,ind(t,:));
    aux=find(ind(t,:)==1);
    for i=1:sum(ind(t,:))

        if PSI(i)==0 | PSI(i) ==1 & PSI(i)~=x(i)
            j=aux(i);
            if kpol>=1
                loglh=-10e10*abs(boldM(j)-boldG(j)-timeeffect(t)-fixedeffect(j)-sum(bpol.*regPOL([t:T:t+(kpol-1)*T],j)))/sigmak(j);  % this adjustment to avoid that the minimization gets stuck here because sigmak too small
            else
                loglh=-10e10*abs(boldM(j)-boldG(j)-timeeffect(t)-fixedeffect(j))/sigmak(j);  % this adjustment to avoid that the minimization gets stuck here because sigmak too small
            end
            logpr=-10e10;
            logpost=-loglh-logpr;
            LOGPOST=logpost;
            return
        elseif PSI(i)==x(i)
            loglh=loglh;
        else
            loglh=loglh+x(i)*log(PSI(i))+(1-x(i))*log(1-PSI(i));
        end
    end

    DK(t,ind(t,:))=X(t,ind(t,:))-(boldM(ind(t,:))>=boldG(ind(t,:)))';
    if kpol>=1
        D(t,ind(t,:))=X(t,ind(t,:))-(boldM(ind(t,:))>=(boldG(ind(t,:))+timeeffect(t)+fixedeffect(ind(t,:))+sum(repmat(bpol,1,sum(ind(t,:))).*regPOLt,1)'))';
    else
        D(t,ind(t,:))=X(t,ind(t,:))-(boldM(ind(t,:))>=(boldG(ind(t,:))+timeeffect(t)+fixedeffect(ind(t,:))))';
    end
    bold=bnew;
    B(:,t+1)=bnew;
    Pold=Pnew;
    invPnew=inv(Pnew);
    STDB(:,t+1)=sqrt(diag(invPnew));
    CCC(:,t+1)=diag(invPnew(1:N,N+1:end));
    invCORR=diag(sqrt(1./diag(Pnew)))*Pnew*diag(sqrt(1./diag(Pnew)));
    ENTROPIA(t+1)=[2*N*log(2*pi*exp(1))-sum(log(diag(Pnew)))-log(det(invCORR))]/(2*log(2));
    
    CORR=diag(sqrt(1./diag(invPnew)))*invPnew*diag(sqrt(1./diag(invPnew)));
    ENTROPIAcorr(t+1)=[2*N*log(2*pi*exp(1))+log(det(CORR))]/(2*log(2));
end


clear bold bnew Pold
% priors

logpr_b0= - N*log(2*pi) - 2*N*log(b0std) - .5*sum((b0 - [repmat(b0mean(1),N,1);repmat(b0mean(2),N,1)]).^2)/(b0std^2);

[junk logpr_S]=pdf_igone(S,degS,scaleS);

[junk logpr_sigmak]=pdf_igone(sigmak,degk,scalek);

if FT==0;
    logpr_FE=0;
else
    logpr_FE= - .5*N*log(2*pi) - N*log(FEstd) - .5*sum((fixedeffect - FEmean).^2)/(FEstd^2);
end

logpr=logpr_b0+sum(logpr_S)+sum(logpr_sigmak)+logpr_FE;


% posterior
LOGPOST=loglh+logpr;