function [B,H,STDdB]=logpost_multicountry_joint_RESULTS_crossing(estpr,Y,X,T,N,ind,priorvec,distance,k,kpol,diagsqrtVCM,XX,XY,regPOL,FT,flagSTDdB);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% parameters bounds and econometrician's priors
b0mean=priorvec(1:2);
b0std=priorvec(3);
scaleS=priorvec(4);
degS=priorvec(5);
minS=priorvec(6);
degk=priorvec(7);
scalek=priorvec(8);
minsigmak=priorvec(9);
maxcorr=priorvec(10);
FEmean=priorvec(11);
FEstd=priorvec(12);


% parameter definitions
b0=estpr(1:2*N);
S=exp(estpr(2*N+1:3*N))+minS;
sigmak=exp(estpr(3*N+1:4*N))+minsigmak;
bdist=exp(estpr(4*N+1:4*N+k));
if kpol>=1
    bpol=estpr(4*N+k+1:4*N+k+kpol);
end
if FT==0;
    fixedeffect=zeros(N,1);
    timeeffect=zeros(T,1);
elseif FT==1
    fixedeffect=estpr(4*N+k+kpol+1:5*N+k+kpol);
    timeeffect=zeros(T,1);
elseif FT==2
    fixedeffect=estpr(4*N+k+kpol+1:5*N+k+kpol);
    timeeffect=estpr(5*N+k+kpol+1:5*N+k+kpol+T);
end


% constructing the prior VCM of the betas
BDIST=repmat(permute(bdist,[3 2 1]),[N,N,1]);
v=maxcorr*exp(-sum(distance(:,:,1:k).*BDIST,3)); v=v-diag(diag(v))+eye(N);
if isinf(bdist)==1;
    v=eye(N);
end
Pold=(kron(eye(2),diag(1./S)*diag(1./diagsqrtVCM)/v*diag(1./diagsqrtVCM)*diag(1./S)));
bold=b0;
H=.5*[N*log(2*pi*exp(1))+4*sum(log(S))+4*sum(log(diagsqrtVCM))+2*log(det(v))]/log(2);


STDdB=zeros(N,T+1);
if flagSTDdB==1;
    invPold=kron(eye(2),diag(S)*diag(diagsqrtVCM)*v*diag(diagsqrtVCM)*diag(S));
    STDdB(:,1)=sqrt(diag(invPold(N+1:2*N,N+1:2*N))+diag(invPold(1:N,1:N))-2*diag(invPold(1:N,N+1:2*N)));
end
B=zeros(2*N,T+1);
B(:,1)=bold;
for t=1:T

    Pnew=Pold+XX(:,(t-1)*2*N+1:t*2*N);
    
    boldG=bold(1:N);
    boldM=bold(N+1:end);
    if flagSTDdB==1;
        invPnew=eye(2*N)/Pnew;
        STDdB(:,t+1)=sqrt(diag(invPnew(N+1:2*N,N+1:2*N))+diag(invPnew(1:N,1:N))-2*diag(invPnew(1:N,N+1:2*N)));
    end
    bnew=Pnew\(Pold*bold+XY(:,t));
%    bnew=[Pnew(1:N,1:N)\(Pold(1:N,1:N)*boldG+XY(1:N,t));Pnew(N+1:end,N+1:end)\(Pold(N+1:end,N+1:end)*boldM+XY(N+1:end,t))];

    bold=bnew;
    B(:,t+1)=bnew;
    Pold=Pnew;
end