function [B]=logpost_multicountry_joint_RESULTS_crossing_new(estpr,Y,X,T,N,ind,priorvec,distance,k,kpol,diagsqrtVCM,XX,XY,regPOL,FT);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% parameters bounds and econometrician's priors
b0mean=priorvec(1:2);
b0std=priorvec(3);
scaleS=priorvec(4);
degS=priorvec(5);
minS=priorvec(6);
degk=priorvec(7);
scalek=priorvec(8);
minsigmak=priorvec(9);
maxcorr=priorvec(10);
FEmean=priorvec(11);
FEstd=priorvec(12);


% parameter definitions
b0=estpr(1:2*N);
S=exp(estpr(2*N+1:3*N))+minS;
sigmak=exp(estpr(3*N+1:4*N))+minsigmak;
bdist=exp(estpr(4*N+1:4*N+k));
if kpol>=1
    bpol=estpr(4*N+k+1:4*N+k+kpol);
end
if FT==0;
    fixedeffect=zeros(N,1);
    timeeffect=zeros(T,1);
elseif FT==1
    fixedeffect=estpr(4*N+k+kpol+1:5*N+k+kpol);
    timeeffect=zeros(T,1);
elseif FT==2
    fixedeffect=estpr(4*N+k+kpol+1:5*N+k+kpol);
    timeeffect=estpr(5*N+k+kpol+1:5*N+k+kpol+T);
end


% constructing the prior VCM of the betas
BDIST=repmat(permute(bdist,[3 2 1]),[N,N,1]);
%v=maxcorr*exp(-sum(distance(:,:,1:k).*BDIST,3)); v=v-diag(diag(v))+eye(N);
v=exp(-sum(distance(:,:,1:k).*BDIST,3)); v=v-diag(diag(v))+eye(N);

if isinf(bdist)==1;
    v=eye(N);
end

Pold_1=kron(eye(2),diag(S)*diag(diagsqrtVCM)*v*diag(diagsqrtVCM)*diag(S));
%Pold=(kron(eye(2),diag(1./S)*diag(1./diagsqrtVCM)/v*diag(1./diagsqrtVCM)*diag(1./S)));
bold=b0;


B(:,1)=bold;
for t=1:T
    
    Pnew_1=(eye(2*N)+Pold_1*XX(:,(t-1)*2*N+1:t*2*N))\Pold_1;
    %Pnew_1=[(eye(N)+Pold_1(1:N,1:N)*XX(1:N,(t-1)*2*N+1:(t-1)*2*N+N))\Pold_1(1:N,1:N) zeros(N);zeros(N) (eye(N)+Pold_1(1:N,1:N)*XX(1:N,(t-1)*2*N+N+1:t*2*N))\Pold_1(1:N,1:N)];
    %Pnew=Pold+XX(:,(t-1)*2*N+1:t*2*N);
    
    boldG=bold(1:N);
    boldM=bold(N+1:end);
    
    bnew=bold+Pnew_1*(XY(:,t)-XX(:,(t-1)*2*N+1:t*2*N)*bold);
    
    %bnew=[Pnew(1:N,1:N)\(Pold(1:N,1:N)*boldG+XY(1:N,t));Pnew(N+1:end,N+1:end)\(Pold(N+1:end,N+1:end)*boldM+XY(N+1:end,t))];

   
    bold=bnew;
    B(:,t+1)=bnew;
    Pold_1=Pnew_1;
end